# > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > >
# This is JustConvert.py, a Python routine that supports the conversion functions available
# in the Notebooks.
#
# Created by: Duarte Fontes
# Email: duarte.fontes@kit.edu
# Last Update: 2/April/2025
# > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > >

import os,sys,re,os.path
from datetime import date
import Converter
import zipfile

import FRExtract
(intname,extname,FCsimp,FCeqs,PrMassFL,GFreno,FRrestr,mygluon,gaugegslist,gslist,mycomplex) = FRExtract.FRextra()

def Addd0(arg):
	auxdot = re.findall(r'(?<![a-zA-Z0-9])(\d+\.?(?<![a-z])\d*)', arg)
	auxdot2=[];
	for i in range(len(auxdot)):
		if auxdot[i] not in auxdot2:
			auxdot2.append(auxdot[i])
	for i in range(len(auxdot2)):
		arg = re.sub(r'(?<![a-zA-Z0-9])'+auxdot2[i]+r'(?![a-zA-Z0-9])',auxdot2[i]+'d0',arg)
	alist=list(arg)
	for i in range(len(alist)):
		if i != (len(alist)-1) and i!=0:
			if alist[i] == 'I' and not alist[i-1].isalnum() and not alist[i+1].isalnum():
				alist[i]='(0d0,1d0)'
		elif i!=0:
			if alist[i] == 'I' and not alist[i-1].isalnum():
				alist[i]='(0d0,1d0)'
		elif i!=(len(alist)-1):
			if alist[i] == 'I' and not alist[i+1].isalnum():
				alist[i]='(0d0,1d0)'					
	arg="".join(alist)
	return arg

dataFR='dataFR.m'
if os.path.isfile(dataFR):
	f1 = open(dataFR, 'r');
	conv = open('MyTeXForm-last-output.tex', 'w')
	f2 = f1.read()
	scribendum=Converter.FCtoTEX(Converter.FRtoFC(f2),'express')
	conv.write(scribendum)
	conv.close()

dataFC='dataFC.m'
if os.path.isfile(dataFC):
	f1 = open(dataFC, 'r');
	conv = open('MyTeXForm-last-output.tex', 'w')
	f2 = f1.read()
	scribendum=Converter.FCtoTEX(f2,'express')
	conv.write(scribendum)
	conv.close()

dataFT='dataFT.m'
if os.path.isfile(dataFT):
	f1 = open(dataFT, 'r');
	f2pre = f1.read().splitlines()
	f2clean=list(filter(('').__ne__, f2pre))

	mycom=f2clean[0]
	tag=mycom.split(';')[0]
	if not tag.isalnum():
		tag='Function'
	myloops=0
	loopcheck=mycom.find('loop')
	if loopcheck != -1:
		myloops=mycom[loopcheck-2]

	auxn = re.findall(r'Process (.*?) at', mycom)[0]
	auxn0 = auxn.split('to')[0]
	auxn0v = auxn0.find(',')
	if auxn0v==-1:
		myprocesssuf = 'decay'
		myprocesspre1='1'
	else:
		myprocesssuf = 'scat'
		myprocesspre1='2'
	auxn1 = auxn.split('to')[1]
	auxn1v = auxn1.find(',')
	if auxn1v==-1:
		myprocesspre2='1'
	else:
		auxn2=auxn1.split(',')
		if len(auxn2)==2:
			myprocesspre2='2'
		else:
			myprocesspre2='3'
	myprocess=myprocesspre1+myprocesspre2+myprocesssuf

	mymasses = f2clean[1].split(',')

	myretil = True if 'True' in f2clean[2] else False

	f2=f2clean[3]
	formfactors=[]
	newexpr=[]	
	for i in range(len(f2clean)-4):
		myaux=f2clean[i+4].split(' -> ', 1)
		formfactors.append(myaux[0].replace(' ',''))
		newexpr.append(myaux[1])

	faux='Matrixind.m'
	rowaux = [];
	if os.path.isfile(faux):
		f = open(faux, 'r');	allLines = f.read().splitlines();	f.close()
		for l in allLines:
			rowaux.append(l)
		rowaux2=[]
		for i in range(len(rowaux)):
			rowaux2.append(rowaux[i].split(', '))
		matnames=[]
		for i in range(len(rowaux2)):
			matnames.append(rowaux2[i][0])
		for h in range(len(matnames)):
			auxmat = re.findall(r''+matnames[h]+r'\[(.*?), (.*?)\]', f2)
			for i in range(len(auxmat)):
				f2=f2.replace(matnames[h]+'[' + auxmat[i][0] + ', ' + auxmat[i][1] + ']',matnames[h]+auxmat[i][0]+auxmat[i][1])	
			for j in range(len(newexpr)):
				auxmat = re.findall(r''+matnames[h]+r'\[(.*?), (.*?)\]', newexpr[j])
				for i in range(len(auxmat)):
					newexpr[j]=newexpr[j].replace(matnames[h]+'[' + auxmat[i][0] + ', ' + auxmat[i][1] + ']',matnames[h]+auxmat[i][0]+auxmat[i][1])
	(scribbasic,nmaxbasic,myvars)=Converter.FCtoFT(f2,myretil)

	scrib2=scribbasic[0][20:]
	newscrib=[]
	nmaxtot=[]
	for i in range(len(newexpr)):
		(prescribendum,nmax,myvars)=Converter.FCtoFT(newexpr[i],myretil)
		newscrib.append(prescribendum)
		nmaxtot.append(nmax)

	fvar = open('MyVariables.h', 'w')
	fvar.write('#if 0\n')
	fvar.write('#endif\n')
	rol=myvars.split(',')

	Goreal='real*8' # choose this for normal precision
	#Goreal='real*16' # choose this for quadrupole precision
	Gocomplex='complex*16' # choose this for normal precision
	#Gocomplex='complex*32' # choose this for quadrupole precision

	for h in range(len(rol)):
		if rol[h] not in mycomplex:
			fvar.write('      ' + Goreal + ' ' + rol[h] + '\n')
		else:
			fvar.write('      '+Gocomplex+' ' + rol[h] + '\n')
	fvar.close()

	# We start by making the general description for the main function
	conv = open('My'+tag+'.F', 'w')
	conv.write('\n')
	nt=53; thestr1='';
	thestr='      '+Gocomplex+' function My'+tag+'(' + myvars + ')\n'
	for t in range(0,len(thestr),nt):
		if (len(thestr)-t)>nt:
			thestr1=thestr1+thestr[t:t+nt]+'\n     & '
		else:
			thestr1=thestr1+thestr[t:t+nt]+'\n'
	rol=myvars.split(',')
	conv.write(thestr1)
	conv.write('      implicit none\n')
	conv.write('      '+Goreal+' Pi\n')
	conv.write('      integer i\n')
	for i in range(nmaxbasic):
		conv.write('      '+Gocomplex+' '+tag+'_'+str(i+1)+'_x\n')
	conv.write('      '+Gocomplex+' '+tag+'V(100000)\n\n')
	conv.write('#include "MyVariables.h"\n')
	if myloops == '1':
		conv.write('#include "looptools.h"\n\n')		
	conv.write('      Pi=acos(-1.d0)\n')
	conv.write('      My'+tag+' = 0d0\n')
	thestr2='';
	for i in range(nmaxbasic):
		thestr='      '+tag+'V('+str(i+1)+')='+tag+'_'+str(i+1)+'_x(' + myvars + ')\n'
		for t in range(0,len(thestr),nt):
			if (len(thestr)-t)>nt:
				thestr2=thestr2+thestr[t:t+nt]+'\n     & '
			else:
				thestr2=thestr2+thestr[t:t+nt]+'\n'
	conv.write(thestr2)	
	conv.write('\n')
	conv.write('      do i=1,' + str(nmaxbasic) + '\n')
	conv.write('            My'+tag+'=My'+tag+'+'+tag+'V(i)\n')
	conv.write('      enddo\n\n')
	conv.write('      return\n')
	conv.write('      end\n\n\n\n')

	# We now write individually the parts of the main expression
	newcount=0
	for i0 in range(nmaxbasic):
		myinflim=10;
		mytrunc=10;
		if i0<myinflim:
			alt=conv
		else:
			if i0 % mytrunc == 0:
				newcount=newcount+1
				alt = open('MyAux_' + tag + '_' + str(newcount) + '.F', 'w')	
		nt=53; thestr2='';
		alt.write('* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\n')
		thestr='      '+Gocomplex+' function '+tag+'_'+str(i0+1)+'_x(' + myvars + ')\n'
		for t in range(0,len(thestr),nt):
			if (len(thestr)-t)>nt:
				thestr2=thestr2+thestr[t:t+nt]+'\n     & '
			else:
				thestr2=thestr2+thestr[t:t+nt]+'\n'
		rol=myvars.split(',')
		alt.write(thestr2)			
		alt.write('      implicit none\n')
		alt.write('      integer i\n')
		alt.write('      '+Goreal+' Pi\n\n')
		alt.write('#include "MyVariables.h"\n')	
		if myloops == '1':
			alt.write('#include "looptools.h"\n\n')				
		for i in range(len(formfactors)):
			alt.write('      '+Gocomplex+' '+ formfactors[i] +','+ formfactors[i] +'_x\n')
		alt.write('\n')
		alt.write('      Pi=acos(-1.d0)\n\n')

		thestr3=''; thestr4='';
		for i in range(len(formfactors)):
			thestr3='      '+formfactors[i]+'='+formfactors[i]+'_x(' + myvars + ')\n'
			for t in range(0,len(thestr3),nt):
				if (len(thestr3)-t)>nt:
					thestr4=thestr4+thestr3[t:t+nt]+'\n     & '
				else:
					thestr4=thestr4+thestr3[t:t+nt]+'\n'

		alt.write(thestr4)	
		alt.write('\n')		
		alt.write(scribbasic[i0].replace('Out('+str(i0+1)+')',tag+'_'+str(i0+1)+'_x'))
		alt.write('\n')
		alt.write('      return\n')
		alt.write('      end\n')
		alt.write('* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *')
		if i0 != nmaxbasic-1:
			alt.write('\n\n\n\n')
		alt.write('\n\n\n\n\n\n')
		if alt != conv:
			if ((i0+1) % mytrunc == 0) or (i0 == (nmaxbasic-1)):
				alt.close()

	# Now, we turn to the main description of the form factors
	for h0 in range(len(nmaxtot)):
		conv.write('* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\n')
		nt=53; thestr2=''
		thestr='      '+Gocomplex+' function '+formfactors[h0]+'_x(' + myvars + ')\n'
		for t in range(0,len(thestr),nt):
			if (len(thestr)-t)>nt:
				thestr2=thestr2+thestr[t:t+nt]+'\n     & '
			else:
				thestr2=thestr2+thestr[t:t+nt]+'\n'
		rol=myvars.split(',')
		conv.write(thestr2)			
		conv.write('      implicit none\n')
		conv.write('      '+Goreal+' Pi\n')
		conv.write('      integer i\n')
		for i in range(nmaxtot[h0]):
			conv.write('      '+Gocomplex+' '+formfactors[h0]+'_x'+str(i+1)+'\n')
		conv.write('      '+Gocomplex+' '+formfactors[h0]+'_y(100000)\n\n')
		conv.write('#include "MyVariables.h"\n')	
		if myloops == '1':
			conv.write('#include "looptools.h"\n\n')
		conv.write('      Pi=acos(-1.d0)\n')
		conv.write('      '+formfactors[h0]+'_x = 0d0\n')
		thestr2='';
		for i in range(nmaxtot[h0]):
			thestr='      '+formfactors[h0]+'_y('+str(i+1)+')='+formfactors[h0]+'_x'+str(i+1)+'(' + myvars + ')\n'
			for t in range(0,len(thestr),nt):
				if (len(thestr)-t)>nt:
					thestr2=thestr2+thestr[t:t+nt]+'\n     & '
				else:
					thestr2=thestr2+thestr[t:t+nt]+'\n'
		conv.write(thestr2)	
		conv.write('\n')
		conv.write('      do i=1,' + str(nmaxtot[h0]) + '\n')
		conv.write('            '+formfactors[h0]+'_x='+formfactors[h0]+'_x+'+formfactors[h0]+'_y(i)\n')
		conv.write('      enddo\n\n')
		conv.write('      return\n')
		conv.write('      end\n\n\n\n')

	# Finally, we write individually the parts of the form factors
		for i0 in range(nmaxtot[h0]):
			if i0<myinflim:
				alt=conv
			else:
				if i0 % mytrunc == 0:
					newcount=newcount+1
					alt = open('MyAux_' + tag + '_' + str(newcount) + '.F', 'w')
			nt=53; thestr2='';
			alt.write('* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\n')
			thestr='      '+Gocomplex+' function '+formfactors[h0]+'_x'+str(i0+1)+'(' + myvars + ')\n'
			for t in range(0,len(thestr),nt):
				if (len(thestr)-t)>nt:
					thestr2=thestr2+thestr[t:t+nt]+'\n     & '
				else:
					thestr2=thestr2+thestr[t:t+nt]+'\n'
			rol=myvars.split(',')
			alt.write(thestr2)				
			alt.write('      implicit none\n')
			alt.write('      integer i\n')
			alt.write('      '+Goreal+' Pi\n\n')
			alt.write('#include "MyVariables.h"\n')
			if myloops == '1':
				alt.write('#include "looptools.h"\n\n')
			alt.write('      Pi=acos(-1.d0)\n\n')
			alt.write(newscrib[h0][i0].replace('Out('+str(i0+1)+')',formfactors[h0]+'_x'+str(i0+1)))
			alt.write('\n')
			alt.write('      return\n')
			alt.write('      end\n\n')
			if ((i0+1) % mytrunc == 0) or (i0 == (nmaxtot[h0]-1)):
				alt.write('* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\n\n')
				if alt!=conv:
					alt.close()
			else:
				alt.write('\n')
	conv.close()

	# What follows is a template of a makefile
	yolo = open('Makefile-template', 'w')
	yolo.write('FC         = ifort\n\n')
	if myloops == '1':
		yolo.write('LT         = /usr/local/lib/LoopTools\n\n')
		yolo.write('FFLAGS	   =   -c -O  -I$(LT)/include\n\n')
	else:
		yolo.write('LT         = \n\n')
		yolo.write('FFLAGS	   =   -c -O \n\n')
	yolo.write('LDFLAGS    =  \n\n')
	yolo.write('LINKER	   = $(FC)\n\n\n\n')
	MyLIB=''
	MyLIBS=''
	if myloops == '1':
		MyLIB += ' -L$(LT)/lib64'
		MyLIBS += ' -looptools'
	if myprocess=='13decay' or myprocess=='23scat':
		MyLIB += ' -L/usr/local/lib/Cuba-4.2'
		MyLIBS += ' -lcuba'
	yolo.write('LIB        =' + MyLIB + '\n')
	yolo.write('LIBS       =' + MyLIBS + '\n\n')
	yolo.write('.F.o:\n')
	yolo.write('	$(FC) $(FFLAGS) $*.F\n')
	yolo.write('.f.o:\n')
	yolo.write('	$(FC) $(FFLAGS) $*.f\n\n\n\n')
	yolo.write('files	= MainFT.o My'+tag+'.o')
	for i7 in range(newcount):
		yolo.write(' MyAux_'+tag+'_'+str(i7+1)+'.o')
	if myprocess == '22scat':
		yolo.write(' IntGauss.o\n')
	elif myprocess == '13decay':
		yolo.write(' Integration3Body.o\n')	
	elif myprocess == '23scat':
		yolo.write(' Integration3Body.o\n')
	else:
		yolo.write(' \n')
	yolo.write('all:	$(files) \n')
	yolo.write('	$(LINKER) $(LDFLAGS) -o MainFT $(files) $(LIB) $(LIBS)\n')
	yolo.close()

	# What follows concerns the parameters of the model at stake
	fPV='ParamsValues.m'
	ecri = open('MyParameters.h', 'w')
	if os.path.isfile(fPV):
		f = open(fPV, 'r');	allLines = f.read().splitlines();	f.close()
		ecri.write('       Parameter(\n')
		totco=0
		for l in allLines:
			totco+=1
			mysplit1=l.split('=')
			if any(mysplit1[0] == x for x in matnames):
				mysplit2=mysplit1[1].split(',')
				for k in range(len(matnames)):
					if mysplit1[0]==matnames[k]:
						count=0
						for k1 in range(int(rowaux2[k][1])):
							if len(rowaux2[k])>2: 
								for k2 in range(int(rowaux2[k][2])):
									if totco == len(allLines) and (k1+1) == int(rowaux2[k][1]) and (k2+1) == int(rowaux2[k][2]):
										ecri.write('     &		'+mysplit1[0]+str(k1+1)+str(k2+1)+'='+Addd0(mysplit2[count])+'\n')
									else:
										ecri.write('     &		'+mysplit1[0]+str(k1+1)+str(k2+1)+'='+Addd0(mysplit2[count])+',\n')
									count+=1
							else:
								if totco == len(allLines) and (k1+1) == int(rowaux2[k][1]):
									ecri.write('     &		'+mysplit1[0]+str(k1+1)+'='+Addd0(mysplit2[count])+'\n')
								else:
									ecri.write('     &		'+mysplit1[0]+str(k1+1)+'='+Addd0(mysplit2[count])+',\n')
								count+=1								
			else:
				if totco == len(allLines):
					ecri.write('     &		'+Addd0(l)+'\n')
				else:
					ecri.write('     &		'+Addd0(l)+',\n')
		ecri.write('     &)\n')
		ecri.close()

	# Finally, we generate the main Fortran file. We start with general stuff
	scri = open('MainFT.F', 'w')
	today = date.today()
	mydate = today.strftime("%B %d, %Y")
	scri.write('*-----------------------------------------------------------------------*\n')
	scri.write('* This program was automatically generated by FeynMaster \n')
	scri.write('* ' + mydate + '\n')
	scri.write('* ' + mycom + '\n')
	scri.write('*-----------------------------------------------------------------------*\n')
	scri.write('      program FCtoFT\n')	
	scri.write('      implicit none\n')	

	# We now consider the particular case of 2->2 scatterings
	if myprocess == '22scat':
		scri.write('      integer i\n')
		scri.write('      '+Goreal+' Pi\n\n')
		if myloops == '1':
			scri.write('      '+Goreal+' lbd2,mu2    ! For LoopTools\n')	
		scri.write('      integer npoints\n')
		scri.write('      '+Goreal+' rs,fx,a,b,integral\n')
		scri.write('      common/parameters/S\n')
		scri.write('      external fx\n\n')
		if myloops == '1':
			scri.write('#include "looptools.h"\n')
		scri.write('#include "MyVariables.h"\n')
		scri.write('#include "MyParameters.h"\n\n')
		if myloops == '1':
			scri.write('      call ltini\n\n')
		scri.write('      open(50,file=\'FTout.dat\',status=\'unknown\')  \n\n')
		scri.write('      Pi=acos(-1.d0)\n\n')
		scri.write('*\n')
		scri.write('**\n')
		scri.write('*** What follows is an example of the integration to calculate the total\n')
		scri.write('*** cross section.\n')
		scri.write('*** It uses a gaussian integration, which requires the choice of a value\n')
		scri.write('*** for npoints. We choose npoints=8, but all the following values are\n')
		scri.write('*** possible: 4,6,8,10,16,20,24,32,64,128 (if npoints is different from\n')
		scri.write('*** these, the program returns fail=-1).\n')
		scri.write('*** The integration calls the function fx, which is defined at the end of\n')
		scri.write('*** this file. It is based on the the quantity My' + tag + ', which is the\n')
		scri.write('*** Fortran version of the quantity the user applied FCtoFT to, and which\n')
		scri.write('*** is assumed to be the differential cross section of the process.\n')
		scri.write('*** Note that the quantity My' + tag + ', besides depending in general on\n')
		scri.write('*** the masses and parameters of the model, also depends explicitly on the\n')
		scri.write('*** center-of-mass energy squared S and the angle Theta. Although the latter\n')
		scri.write('*** should be integrated between 0 and Pi (as in the example that follows), \n')
		scri.write('*** S is free. In the example that follows, we perform the integral for values \n')
		scri.write('*** of sqrt(S) between 10 and 900 GeV.\n')
		scri.write('**\n')
		scri.write('*\n\n')
		scri.write('      npoints=8\n')
		if myloops == '1':
			scri.write('      rs=10d0 -0.5d0 + 1d-6\n')
		else:
			scri.write('      rs=10d0 -0.5d0\n')
		scri.write('      a=0d0\n')
		scri.write('      b=Pi\n')
		scri.write('      do i=1,901\n')
		scri.write('         rs=rs+0.5d0\n')
		scri.write('         S=rs**2\n\n')
		scri.write('         call gauss1D(npoints, fx, a, b, integral)\n')
		scri.write('         write(50,98)rs,integral\n')
		scri.write('      enddo\n\n')
		scri.write('* Final declarations:\n')
		if myloops == '1':
			scri.write('      call ltexi\n\n')
		scri.write(' 98   format(6(e13.5,1x))\n\n')
		scri.write('      end\n\n')
		scri.write('*\n')
		scri.write('**\n')
		scri.write('*** We now define the function fx\n')
		scri.write('**\n')
		scri.write('* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\n')
		scri.write('      '+Goreal+' function fx(Theta)\n')
		scri.write('      implicit none\n\n')
		scri.write('      '+Goreal+' Pi\n')
		scri.write('      '+Goreal+' factor\n')
		scri.write('      '+Gocomplex+' My'+tag+',fxCmplx\n\n')
		scri.write('#include "MyVariables.h"\n')
		scri.write('#include "MyParameters.h"\n\n')
		scri.write('      common/parameters/S\n\n')		
		scri.write('*\n')
		scri.write('***  To convert from GeV to ob, we use: 1GeV^(-2)= 3.893795 10^(8) pb\n')
		scri.write('*\n')
		scri.write('      factor=3.893795d+08\n\n')
		scri.write('      Pi=acos(-1d0)\n\n')
		scri.write('      fxCmplx='+thestr1[26:])
		scri.write('      fx=real(fxCmplx) * factor * 2d0*Pi * sin(Theta)\n\n')
		scri.write('      return\n')
		scri.write('      end\n')
		scri.write('* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\n')

	# We now consider the particular case of 1->3 decays
	elif myprocess == '13decay':
		scri.write('      integer i,method,npoints\n\n')
		scri.write('      '+Goreal+' xrs,xma,xmb,xm1,xm2,xm3,Pi\n')
		scri.write('      '+Goreal+' M0,width\n')
		scri.write('      character*7 DecayOrXs\n\n')
		scri.write('#include "MyVariables.h"\n')
		scri.write('#include "MyParameters.h"\n\n')
		scri.write('      common/parameters/xrs,xma,xmb,xm1,xm2,xm3\n')
		scri.write('      common/Type/DecayOrXs\n\n')
		for i in range(len(mymasses)):
			scri.write('      '+mymasses[i]+'\n')
		scri.write('\n')
		scri.write('      open(10,file=\'res.dat\',status=\'unknown\')\n')
		scri.write('      DecayOrXs=\'Decay13\'\n\n')
		scri.write('      Pi=acos(-1.d0)\n\n')
		scri.write('*\n')
		scri.write('**\n')
		scri.write('*** What follows is an example of the integration to calculate the total\n')
		scri.write('*** decay width.\n')
		scri.write('*** The integral can be performed with via gaussian (method 1) or vegas\n')
		scri.write('*** (method 2) integration, both of which require the choice of a value\n')
		scri.write('*** for npoints. In what follows, we choose method=2 and npoints=16.\n')
		scri.write('*** Note that, for the method=1, all the following values are possible:\n')
		scri.write('*** 4,6,8,10,16,20,24,32,64,128 (if npoints is different from these,\n')
		scri.write('*** the program returns fail=-1).\n')
		scri.write('*** The integration function is DecayWidth; it is defined elsewhere;\n')
		scri.write('*** its outcome is defined as decaywidth. \n')
		scri.write('*** DecayWidth depends on function Msq, which is defined at the end of\n')
		scri.write('*** this file. Msq is based on the the quantity My' + tag + ', which is\n')
		scri.write('*** the Fortran version of the quantity the user applied FCtoFT to, and\n')
		scri.write('*** which is assumed to be the averaged |M|^2 of the process (with\n')
		scri.write('*** symmetry factors included). The user should not modify Msq. \n')
		scri.write('**\n')
		scri.write('*\n\n')
		scri.write('      method=2\n')
		scri.write('      npoints=16\n')
		scri.write('      call DecayWidth(width,method,npoints)\n\n')
		scri.write('      write(10,99)xrs,width\n\n')
		scri.write(' 99   format(3(e14.5,2x))\n')
		scri.write('      end\n')
		scri.write('\n\n')
		scri.write('*\n')
		scri.write('**\n')
		scri.write('*** We now define the function Msq\n')
		scri.write('**\n')
		scri.write('* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\n')
		scri.write('      '+Goreal+' function Msq(P0P0,P0q1,P0q2,P0q3,q1q2,q1q3,q2q3)\n')
		scri.write('      implicit none\n\n')
		#scri.write('      '+Goreal+' xrs,xma,xmb,xm1,xm2,xm3\n')
		scri.write('      '+Gocomplex+' My'+tag+',Msqaux\n\n')
		scri.write('#include "MyVariables.h"\n')
		scri.write('#include "MyParameters.h"\n\n')
		#scri.write('      common/parameters/xrs,xma,xmb,xm1,xm2,xm3\n\n')
		scri.write('      Msqaux='+thestr1[26:])
		scri.write('      Msq=real(Msqaux)\n\n')
		scri.write('      return\n')
		scri.write('      end\n')
		scri.write('* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\n')


	# We now consider the particular case of 2->3 scatterings
	elif myprocess == '23scat':	
		scri.write('      integer i,method,npoints\n\n')
		scri.write('      '+Goreal+' xrs,xma,xmb,xm1,xm2,xm3,Pi\n')
		scri.write('      '+Goreal+' xs(1),xsection\n')
		scri.write('      character*7 DecayOrXs\n\n')
		scri.write('#include "MyVariables.h"\n')
		scri.write('#include "MyParameters.h"\n\n')
		scri.write('      common/parameters/xrs,xma,xmb,xm1,xm2,xm3\n')
		scri.write('      common/Type/DecayOrXs\n\n')
		for i in range(len(mymasses)):
			scri.write('      '+mymasses[i]+'\n')
		scri.write('\n')
		scri.write('      open(10,file=\'res.dat\',status=\'unknown\')\n')
		scri.write('      DecayOrXs=\'XSect23\'\n\n')
		scri.write('      Pi=acos(-1.d0)\n\n')
		scri.write('*\n')
		scri.write('**\n')
		scri.write('*** What follows is an example of the integration to calculate the total\n')
		scri.write('*** cross section.\n')
		scri.write('*** The integral can be performed with via gaussian (method 1) or vegas\n')
		scri.write('*** (method 2) integration, both of which require the choice of a value\n')
		scri.write('*** for npoints. In what follows, we choose method=2 and npoints=16.\n')
		scri.write('*** Note that, for the method=1, all the following values are possible:\n')
		scri.write('*** 4,6,8,10,16,20,24,32,64,128 (if npoints is different from these,\n')
		scri.write('*** the program returns fail=-1).\n')
		scri.write('*** The integration function is sigma; it is defined elsewhere;\n')
		scri.write('*** its outcome is defined as xs(1). \n')
		scri.write('*** sigma depends on function Msq, which is defined at the end of\n')
		scri.write('*** this file. Msq is based on the the quantity My' + tag + ', which is\n')
		scri.write('*** the Fortran version of the quantity the user applied FCtoFT to, and\n')
		scri.write('*** which is assumed to be the averaged |M|^2 of the process (with\n')
		scri.write('*** symmetry factors included). The user should not modify Msq. \n')
		scri.write('*** The cross section xs(1) depends on the center-of-mass energy xrs.\n')
		scri.write('*** In the example that follows, we perform the integral for values \n')
		scri.write('*** of xrs between 100 and 500 GeV\n')
		scri.write('**\n')
		scri.write('*\n\n')
		scri.write('      method=2\n')
		scri.write('      npoints=16\n')
		scri.write('      xrs=99d0\n')
		scri.write('      do i=1,401\n')
		scri.write('         xrs=xrs+1.d0\n')
		scri.write('         call sigma(xs,method,npoints)\n')
		scri.write('         xsection=xs(1)\n')
		scri.write('         write(10,99)xrs,xsection\n')
		scri.write('      enddo\n\n')
		scri.write(' 99   format(3(e14.5,2x))\n')
		scri.write('      end\n\n')
		scri.write('*\n')
		scri.write('**\n')
		scri.write('*** We now define the function Msq\n')
		scri.write('**\n')
		scri.write('* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\n')
		scri.write('      '+Goreal+' function Msq(p1p2,p1q1,p1q2,p1q3,p2q1,p2q2,p2q3,\n')
		scri.write('     &     q1q2,q1q3,q2q3,EPSp1p2q1q2)\n')
		scri.write('      implicit none\n\n')
		#scri.write('      '+Goreal+' xrs,xma,xmb,xm1,xm2,xm3\n')
		scri.write('      '+Gocomplex+' My'+tag+',Msqaux\n\n')
		scri.write('#include "MyVariables.h"\n')
		scri.write('#include "MyParameters.h"\n\n')
		#scri.write('      common/parameters/xrs,xma,xmb,xm1,xm2,xm3\n\n')
		scri.write('      Msqaux='+thestr1[26:])
		scri.write('      Msq=real(Msqaux)\n\n')
		scri.write('      return\n')
		scri.write('      end\n')
		scri.write('* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\n')


	# We now consider all the other cases
	else:
		scri.write('      integer i\n')
		scri.write('      '+Goreal+' Pi\n\n')
		if myloops == '1':
			scri.write('      '+Goreal+' lbd2,mu2    ! For LoopTools\n')	
		scri.write('      '+Gocomplex+' My'+tag+'\n\n')
		if myloops == '1':
			scri.write('#include "looptools.h"\n')
		scri.write('#include "MyVariables.h"\n')
		scri.write('#include "MyParameters.h"\n\n')
		if myloops == '1':
			scri.write('      call ltini\n\n')
		scri.write('      open(50,file=\'FTout.dat\',status=\'unknown\')  \n\n')
		scri.write('      Pi=acos(-1.d0)\n\n')
		scri.write('* Write now the rest of the program\n')
		scri.write('\n\n\n\n\n\n')
		scri.write('* Final declarations:\n')
		if myloops == '1':
			scri.write('      call ltexi\n\n')
		scri.write(' 98   format(6(e13.5,1x))\n\n')
		scri.write('      end\n')
	scri.close()


	# At last, we collect all necessary files
	mlist = ['My'+tag+'.F','MainFT.F','MyVariables.h','MyParameters.h','Makefile-template']
	for i5 in range(newcount):
		mlist.append('MyAux_' + tag + '_' + str(i5+1) + '.F')
	if myprocess == '22scat':
		mlist.append('IntGauss.f')
	elif myprocess == '13decay' or myprocess == '23scat':
		mlist.append('Integration3Body.f')
	with zipfile.ZipFile('movendum.zip', 'w') as zipMe:        
	    for file in mlist:
	        zipMe.write(file, compress_type=zipfile.ZIP_DEFLATED)
	if myprocess == '22scat' or myprocess == '13decay' or myprocess == '23scat':
		for i5 in range(len(mlist)-1):
			os.remove(mlist[i5])
	else:
		for i5 in range(len(mlist)):
			os.remove(mlist[i5])

